import React from 'react';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import Icon from '@highlight-ui/icon';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles = {"button":"Button-module__3Rp1BYXs__v2-0-4","loadingButtonInner":"Button-module__1JxCag8q__v2-0-4","loadingIcon":"Button-module__PkJtfsRC__v2-0-4","buttonInner":"Button-module__3ZNLhdsJ__v2-0-4","iconOnly":"Button-module__3-vgpZJs__v2-0-4","block":"Button-module__1xc1DTHJ__v2-0-4","default":"Button-module__2Kmo3l-q__v2-0-4","focus":"Button-module__39s3axLP__v2-0-4","active":"Button-module__3WXlxxv-__v2-0-4","disabled":"Button-module__yB64MUUF__v2-0-4","primary":"Button-module__2nxVbZSO__v2-0-4","success":"Button-module__2WMN2Up2__v2-0-4","info":"Button-module__3Ll-h-cW__v2-0-4","warning":"Button-module__2Ma4TaUU__v2-0-4","warning-light":"Button-module__2HCrlzv6__v2-0-4","danger":"Button-module__3Eex2siA__v2-0-4","dark":"Button-module__MqwKA-Vc__v2-0-4","light":"Button-module__iJhDdOHm__v2-0-4","defaultOutline":"Button-module__2tKStPHe__v2-0-4","hover":"Button-module__YUN3Kf-p__v2-0-4","link":"Button-module__2KZcoTpE__v2-0-4"};

function ButtonWithRef(_a, ref) {
    var _b, _c, _d, _e, _f, _g;
    var _h = _a.actAsAnchor, actAsAnchor = _h === void 0 ? false : _h, _j = _a.active, active = _j === void 0 ? false : _j, block = _a.block, _k = _a.children, children = _k === void 0 ? null : _k, className = _a.className, _l = _a.disabled, disabled = _l === void 0 ? false : _l, icon = _a.icon, loading = _a.loading, metadata = _a.metadata, _m = _a.onClick, onClick = _m === void 0 ? undefined : _m, outline = _a.outline, _o = _a.theme, theme = _o === void 0 ? 'default' : _o, _p = _a.type, type = _p === void 0 ? 'button' : _p, remainingProps = __rest(_a, ["actAsAnchor", "active", "block", "children", "className", "disabled", "icon", "loading", "metadata", "onClick", "outline", "theme", "type"]);
    var tag = actAsAnchor ? 'a' : 'button';
    var containerClass = classnames(styles.button, (_b = {}, _b[styles[theme]] = !outline, _b), (_c = {}, _c[styles[theme + "Outline"]] = outline, _c), (_d = {}, _d[styles.block] = block, _d), (_e = {}, _e[styles.active] = active || loading, _e), (_f = {}, _f[styles.disabled] = disabled, _f), className);
    var focusAwareOnClick = function (event) {
        if (!actAsAnchor)
            event.currentTarget.focus();
        if (onClick)
            onClick(event);
    };
    return React.createElement(tag, __assign(__assign(__assign({}, remainingProps), parseMetadata(metadata)), { className: containerClass, disabled: disabled, onClick: disabled ? undefined : focusAwareOnClick, type: tag === 'button' ? type : undefined, ref: ref }), React.createElement(React.Fragment, null,
        React.createElement("div", { className: classnames(styles.buttonInner, (_g = {},
                _g[styles.loadingButtonInner] = loading,
                _g)) },
            icon && React.createElement(Icon, { name: icon, size: 15 }),
            children && React.createElement("div", { className: styles.buttonContent }, children)),
        loading && (React.createElement(Icon, { name: "spinner-third", size: 15, spin: true, className: styles.loadingIcon }))));
}
ButtonWithRef.displayName = 'Button';
var Button = React.forwardRef(ButtonWithRef);

export default Button;
//# sourceMappingURL=index.js.map
